﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace KuduRestClient
{
    public class ScmInfo
    {
        public int Type { get; set; }
        public string GitUrl { get; set; }
    }

    public class CommandInfo
    {
        public string command { get; set; }
        public string dir { get; set; }
    }

    public class MessageResponse
    {
        public HttpStatusCode HttpResultCode { get; set; }
        public string Message { get; set; }
        public string ExceptionMessage { get; set; }
        public string ExceptionType { get; set; }
        public string StackTrace { get; set; }
    }

    public class CommandOutput
    {
        public bool Result { get; set; }
        public string Output { get; set; }
        public string Error { get; set; }
        public int ExitCode { get; set; }
    }

    public class FileContent
    {
        public string etag { get; set; }
        public string text { get; set; }
    }

    public class VfsFile
    {
        public string name { get; set; }
        public int size { get; set; }
        public DateTime mtime { get; set; }
        public DateTime crtime { get; set; }
        public string mime { get; set; }
        public string href { get; set; }
        public string path { get; set; }

        public override string ToString()
        {
            return $"{href} ({mtime})";
        }
    }

    public class SiteExtensionItem
    {
        public string id { get; set; }
        public string title { get; set; }
        public string type { get; set; }
        public string summary { get; set; }
        public string description { get; set; }
        public string version { get; set; }
        public string extension_url { get; set; }
        public string project_url { get; set; }
        public string icon_url { get; set; }
        public string license_url { get; set; }
        public string feed_url { get; set; }
        public List<string> authors { get; set; }
        public string installer_command_line_params { get; set; }
        public DateTime? published_date_time { get; set; }
        public int download_count { get; set; }
        public bool? local_is_latest_version { get; set; }
        public string local_path { get; set; }
        public DateTime installed_date_time { get; set; }
        public string provisioningState { get; set; }
        public string comment { get; set; }

        public override string ToString()
        {
            return extension_url;
        }
    }


    public class Thread
    {
        public int id { get; set; }
        public string href { get; set; }
        public string state { get; set; }
    }

    public class Module
    {
        public string base_address { get; set; }
        public string file_name { get; set; }
        public string href { get; set; }
        public string file_version { get; set; }
    }

    public class ProcessInfo
    {
        public int id { get; set; }
        public string name { get; set; }
        public string href { get; set; }
        public string minidump { get; set; }
        public double iis_profile_timeout_in_seconds { get; set; }
        public string parent { get; set; }
        public List<string> children { get; set; }
        public List<Thread> threads { get; set; }
        public List<string> open_file_handles { get; set; }
        public List<Module> modules { get; set; }
        public string file_name { get; set; }
        public string command_line { get; set; }
        public string user_name { get; set; }
        public int handle_count { get; set; }
        public int module_count { get; set; }
        public int thread_count { get; set; }
        public DateTime start_time { get; set; }
        public string total_cpu_time { get; set; }
        public string user_cpu_time { get; set; }
        public string privileged_cpu_time { get; set; }
        public int working_set { get; set; }
        public int peak_working_set { get; set; }
        public int private_memory { get; set; }
        public int virtual_memory { get; set; }
        public int peak_virtual_memory { get; set; }
        public int paged_system_memory { get; set; }
        public int non_paged_system_memory { get; set; }
        public int paged_memory { get; set; }
        public int peak_paged_memory { get; set; }
        public DateTime time_stamp { get; set; }
        public Dictionary<string, string> environment_variables { get; set; }
    }
}
